# Comrade

[![Dev](https://img.shields.io/badge/docs-dev-blue.svg)](https://ptiede.github.io/Comrade.jl/dev/)
[![Build Status](https://github.com/ptiede/Comrade.jl/workflows/CI/badge.svg)](https://github.com/ptiede/Comrade.jl/actions)
[![Coverage](https://codecov.io/gh/ptiede/Comrade.jl/branch/main/graph/badge.svg)](https://codecov.io/gh/ptiede/Comrade.jl)
[![ColPrac: Contributor's Guide on Collaborative Practices for Community Packages](https://img.shields.io/badge/ColPrac-Contributor's%20Guide-blueviolet)](https://github.com/SciML/ColPrac)

Composable Modeling of Radio Emission

This is a alpha version of a potential EHT/ngEHT modeling/imaging software written in Julia. The objectives are in order of importance

1. Simple to define and adjust models and parameterizations
2. Everything must be differentiable with Julia's autodifferentation libraries
3. Speed. The code must be fast, with proper SIMD, GPU, and distributed computing support

# Installation
To install Comrade.jl you must use Julia's package manager. For example you can launch your Julia session with then type `]` to move into Pkg mode. Once in pkg mode type
```julia
add Comrade
```
To perform inference i.e. parameter estimation you should look at the `lib` packages. 

<!-- # Roadmap

1. Settle on model interface
2. Design a better data maniuplation interface and native uvfits reading (or spin up the EHTIM.jl package)
2. ~Full gain~ and polarization implemented, including DTERM modeling ala DMC, and approximate methods such as pseudo-marginal, particle MCMC methods, or laplace approximations
3. Write model adjoints when needed for additional speed (and define a may to define AD backends like Zygote, Enzyme, Diffractor, etc.)
4. GPU support when its a good idea (maybe for gain solves?)
 -->
